/* 
 * vMac Patches File
 * Michael Hanni (mhanni@sprintmail.com)
 * (C) 1998 vMac Group
 */

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "custom.h"
#include "prefs.h"

#include "memory2.h"                    // includes/memory.h

#include "Memory.h"
#include "uaepatch.h"                   // includes/uae_vmac_patch.h
#include "custom2.h"                    // includes/vMac_custom.h

#include "readcpu.h"
#include "newcpu.h"

#include "Native.h"
#include "PatchMgr.h"
#include "Sony.h"

#include "screen.h"
#include "IBM-TIME.h"

#include <signal.h>

#include "../unix/universa.h"

extern int GUI, use_debugger, quit_program;
int Screen_Patch=0, hideCursor=0, showCursor=0;

int Check_vMac_Patches(void)
{
   switch ((UWORD) get_word(m68k_getpc())) {
      case _GetNamedResource: {
         CPTR NamePtr = 0;
         UWORD *SonyPtr = NULL;

         extern UBYTE Sony_Installed;

         if (Sony_Installed == 0) {
            NamePtr = get_long(m68k_areg(regs, 7));
            if ((get_long(NamePtr) == 0x052E536F) && (get_word(NamePtr+4) == 0x6E79) && (get_long(m68k_areg(regs, 7) + 4)) == 0x44525652) { 
               Run_ATrap(); // Call GetNamedResource
               Sony_Install();
               return 1;
            } else {
               return 0;
            }
         }

         break;
      }

      case _InitGraf: {
         Run_ATrap();
         if (thePrefs.Big)
            patch_screen();

         return 1;
         break;
      }
         
      default: {
         return 0;
         break;
      }
   }

   return 0; // This is to satisfy GCC complaint.
}

int patch_globals (void)
{
   // SCSI chip is available..
   put_word(0xb22, get_word(0xb22) | 0x8000);

   // Let the mac know what CPU (and FPU) we're using..
   if (CPU_LEVEL<3) {
      put_byte(0x12F, CPU_LEVEL);
   } else {
      put_byte(0x12F, 0x02);
      put_word(0xb22, get_word(0xb22) | 0x1000);
   }

   return 1;
}

int patch_screen (void)
{
   ULONG QD_Global, screenBits, crsrPin = 0x834, thePort;
   UWORD Right  = (thePrefs.Big==1) ? Right1  : Right2;
   UWORD Bottom = (thePrefs.Big==1) ? Bottom1 : Bottom2;
   CPTR  jHideCursor=0x800, jShowCursor=0x804, ptr;

   // patch the QD globals
   thePort    = get_long(m68k_areg(regs, 5));
   QD_Global  = thePort - (206 - 4);
   screenBits = QD_Global + 80;

   // patch up the QD globals
   put_long(screenBits   , scrnBase);
   put_word(screenBits+4 , rowBytes2);
   put_word(screenBits+6 , Top);
   put_word(screenBits+8 , Left);
   put_word(screenBits+10, Bottom);
   put_word(screenBits+12, Right);
   
   // patch the low-level globals
   put_long(0x824, scrnBase);
   put_word(0x106, rowBytes2);  
   put_word(0xc20, Right);
   put_word(0xc22, Bottom);

   if (thePrefs.Big==1)
      put_long(0xc24, screenBytes1);
   else
      put_long(0xc24, screenBytes2);

   // patch up mouse for the new screen size
   put_word(crsrPin,   Top);
   put_word(crsrPin+2, Left);
   put_word(crsrPin+4, Bottom);
   put_word(crsrPin+6, Right);

   // Patch ROM routines [Not very efficient, but generic, which is what
   // we need here]. 

      ROMmem_write_enable_set(on);

      // patch _HideCursor
      ptr = get_long(jHideCursor);
      do {                                   // loop through the routine ...
         if (get_long(ptr)==0x70402298)      // patch MOVE.l #$40, D0
            put_byte(ptr+1, rowBytes2);      
         ptr+=2;
      } while (get_long(ptr)!=0x4e75);       // ... until we reach RTS.l

      // patch _ShowCursor
      ptr = get_long(jShowCursor);
      do {                                   // loop through the routine ...
         if (get_long(ptr)==0x7a40c2c5)      // patch MOVE.l #$40, D5
            put_byte(ptr+1, rowBytes2);      
         if (get_long(ptr)==0x0c4001e0)      // patch CMP.w #$01e0, D0
            put_word(ptr+2, Right-0x20);  
         if (get_long(ptr)==0x303c01e0)      // patch MOVE.w #$01e0, D0
            put_word(ptr+2, Right-0x20);  
         if (get_long(ptr)==0x0c410146)      // patch CMP.w #$0146, D1
            put_word(ptr+2, Bottom-0x10);
         if (get_long(ptr)==0x383c0156)      // patch MOVE.w #$0156, D4
            put_word(ptr+2, Bottom);
            ptr+=2;
      } while (get_long(ptr)!=0x4e75);       // ... until we reach RTS.l

      ROMmem_write_enable_set(off);

   Screen_Patch=1;
   return 1;
}

int patch_alert (void)
{
   ULONG dsRect = 0x3f8;
   UWORD dsTop, dsLeft, dsBottom, dsRight, dsHeight, dsWidth;
   UWORD Right = Right2, Bottom = Bottom2;

   if (thePrefs.Big) {
      dsTop    = get_word(dsRect  );
      dsLeft   = get_word(dsRect+2);
      dsBottom = get_word(dsRect+4);
      dsRight  = get_word(dsRect+6);
      dsHeight = dsBottom - dsTop;
      dsWidth  = dsRight - dsLeft;

      put_word(dsRect,   dsTop);
      put_word(dsRect+2, Left+0x60);
      put_word(dsRect+4, dsTop+dsHeight);
      put_word(dsRect+6, Left+0x60+dsWidth);
   }

   return 1;
}
