// Cross Platform Compatible Preferences Code for vMac
// (C) 1997 Richard Bannister

// Based on code from Frodo - (C) 1994-1997 Christian Bauer

#include "sysconfig.h"
#include "sysdeps.h"
#include "prefs.h"

Prefs thePrefs;

void PrefsLoad(char *filename)
{
   FILE *file;
   char line[256], keyword[256], value[256];

   // Initialise the prefs with valid values
   thePrefs.Skip=0;
   thePrefs.Big=0;
   thePrefs.Sound=0;
   thePrefs.VBL=0;
   thePrefs.Printer=0;
   strcpy(thePrefs.DrivePath[0], "");
   strcpy(thePrefs.DrivePath[1], "");
   strcpy(thePrefs.DrivePath[2], "");
   strcpy(thePrefs.DrivePath[3], "");
   strcpy(thePrefs.ROMPath[1],"vMac.ROM");
   thePrefs.CurrentROMPath=1;
   thePrefs.RAMSize=1;

   if ((file = fopen(filename, "r")) != NULL) {
      while (fgets(line, 255, file)) {
         if (sscanf(line, "%s = %s\n", keyword, value) == 2) {
            if (!strcmp(keyword, "SkipMemoryTest")){
               if (!strcmp(value, "1"))
                  thePrefs.Skip=1;
               else
                  thePrefs.Skip=0;

            if (!strcmp(keyword, "QDHack")) {
               if (!strcmp(value, "1"))  thePrefs.Big=1;
               else if (!strcmp(value, "2")) thePrefs.Big=2;
               else thePrefs.Big=0;
            }

            if (!strcmp(keyword, "Sound")) {
               if (!strcmp(value, "1"))
                  thePrefs.Sound=1;
               else
                  thePrefs.Sound=0;
            }

            if (!strcmp(keyword, "VBL")) {
               if (!strcmp(value, "1"))
                  thePrefs.VBL=1;
               else
                  thePrefs.VBL=0;
            }

            if (!strcmp(keyword, "Printer")) {
               if (!strcmp(value, "1"))  thePrefs.Printer=1;
               else if (!strcmp(value, "2"))  thePrefs.Printer=2;
               else if (!strcmp(value, "3"))  thePrefs.Printer=3;
               else thePrefs.Printer=0;
            }

            if (!strcmp(keyword, "RAMSize")) {
               if (!strcmp(value, "1"))  thePrefs.RAMSize = 1;
               else if (!strcmp(value, "2"))  thePrefs.RAMSize = 2;
               else if (!strcmp(value, "4"))  thePrefs.RAMSize = 4;
               else thePrefs.RAMSize=1;
            }

            if (!strcmp(keyword, "DrivePath1"))
               strcpy(thePrefs.DrivePath[1], value);

            if (!strcmp(keyword, "DrivePath2"))
               strcpy(thePrefs.DrivePath[2], value);

            if (!strcmp(keyword, "DrivePath3"))
               strcpy(thePrefs.DrivePath[3], value);

            if (!strcmp(keyword, "ROMPath1"))
               strcpy(thePrefs.ROMPath[1],value);

            if (!strcmp(keyword, "ROMPath2"))
               strcpy(thePrefs.ROMPath[2],value);

            if (!strcmp(keyword, "ROMPath3"))
               strcpy(thePrefs.ROMPath[3],value);

            if (!strcmp(keyword, "CurrentROMPath")) {
               if (!strcmp(value, "1"))  thePrefs.CurrentROMPath = 1;
               else if (!strcmp(value, "2"))  thePrefs.CurrentROMPath = 2;
               else if (!strcmp(value, "3"))  thePrefs.CurrentROMPath = 3;
               else thePrefs.CurrentROMPath = 1;
            }
         }
      }
      fclose(file);
   }
}

void PrefsSave(char *filename)
{
   FILE *file;

   if ((file = fopen(filename, "w")) != NULL) {
      fprintf(file, "// vMac Configuration File\n");
      fprintf(file, "//\n");
        
      fprintf(file, "\n");
        
      fprintf(file, "// Do you wish to skip the Macintosh power-on memory \n");
      fprintf(file, "// test ?  This might be useful on slower computers  \n");
      fprintf(file, "// or when the there's a large RAM size [see below]  \n");
      fprintf(file, "// (Do memory test = 0, Skip memory test = 1).     \n\n");
      fprintf(file, "SkipMemoryTest = %d\n\n", thePrefs.Skip);

      fprintf(file, "// This will hack QuickDraw to gain speed, as well  \n");
      fprintf(file, "// as higher resolutions.                           \n");
      fprintf(file, "// (0 = Off, 1 = On - 512x342, 2 = On - 640x480)  \n\n");
      fprintf(file, "QDHack = %d\n\n", thePrefs.Big);

      fprintf(file, "// Sound emulation.                                 \n");
      fprintf(file, "// (0 = Off, 1 = On)                              \n\n");    
      fprintf(file, "Sound = %d\n\n", thePrefs.Sound);

      fprintf(file, "// This can be set to sync. vMac with the host VBL. \n");
      fprintf(file, "// Effective when you want to control vMac's speed, \n");
      fprintf(file, "// for accuracy.                                    \n");
      fprintf(file, "// (0 = Off, 1 = On)                              \n\n");    
      fprintf(file, "VBL = %ld\n\n", thePrefs.VBL);

      fprintf(file, "// Printer emulation [Experimental!].                \n");
      fprintf(file, "// (0 = Off, 1 - 3 = Printer port LPTx)            \n\n");
      fprintf(file, "Printer = %ld\n\n", thePrefs.Printer);

      fprintf(file, "// How much RAM do you want the emulated Mac Plus to \n");
      fprintf(file, "// have? (1 = 1 Mb, 2 = 2Mb, 4 = 4Mb).             \n\n");
      fprintf(file, "RAMSize = %d\n\n", thePrefs.RAMSize);

      fprintf(file, "// Which disks are in the emulated disk drives? Where\n");
      fprintf(file, "// are they located?                               \n\n");
      fprintf(file, "DrivePath1 = %s\n", thePrefs.DrivePath[1]);
      fprintf(file, "DrivePath2 = %s\n", thePrefs.DrivePath[2]);
      fprintf(file, "DrivePath3 = %s\n\n", thePrefs.DrivePath[3]);

      fprintf(file, "// And where is the vMac.ROM file? If you have more  \n");
      fprintf(file, "// than one you can put in the path for them all and \n");
      fprintf(file, "// vMac will allow you to switch between them!     \n\n");
      fprintf(file, "ROMPath1 = %s\n", thePrefs.ROMPath[1]);
      fprintf(file, "ROMPath2 = %s\n", thePrefs.ROMPath[2]);
      fprintf(file, "ROMPath3 = %s\n", thePrefs.ROMPath[3]);
      fprintf(file, "CurrentROMPath = %d\n\n", thePrefs.CurrentROMPath);

      fprintf(file, "\n");
      fprintf(file, "// End of File");
      fclose(file);
   }
}
